// Vid32Dev.h: interface for the CVid32Dev class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VID32DEV_H__72768E03_9B5A_461F_8EAA_BB38880F307A__INCLUDED_)
#define AFX_VID32DEV_H__72768E03_9B5A_461F_8EAA_BB38880F307A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "IldevBase.h"
#include "StaticTerm.h"

class CVid32Dev : public CIldevBase
{
public:
	CVid32Dev(CStaticTerm& wndScreen,INT nCols,INT nRows);
	virtual ~CVid32Dev();

private:
	// video emulation
	CStaticTerm& m_wndScreen;				// screen buffer

	INT  m_nVisCols;						// no. of visible columns
	INT  m_nVisRows;						// no. of visible rows

	BYTE *m_pbyBuffer;						// video buffer

	INT  m_nBufRows;						// no. of buffer rows
	INT  m_nBufLine;						// buffer line of screen view

	INT  m_xCurPos; 						// actual x cursor position
	INT  m_yCurPos; 						// actual y cursor position

	bool m_bCursorShow; 					// show cursor
	enum CUR_STATE m_eCurState;				// actual cursor state

	INT  m_nEsc;							// escape sequence
	bool m_bAutoCrLf;						// evaluated automatic CR LF

	VOID SyncScreen();
	VOID SetCursorPos(INT x, INT y);
	VOID CursorLeft();
	VOID CursorRight();
	VOID EvalLF();

	VOID ClearDevice() override;			// clear device
	VOID InData(WORD wFrame) override;		// listener transfer
};

#endif // !defined(AFX_VID32DEV_H__72768E03_9B5A_461F_8EAA_BB38880F307A__INCLUDED_)
